import 'package:dio/dio.dart';
import 'package:flutter/material.dart';
import 'package:lori_sdk/data/api/sales/commerce/sales_commerce_api.dart';
import 'package:lori_sdk/data/api/sales/sales_catalog_api.dart';
import 'package:lori_sdk/data/api/sales/sales_marketing_api.dart';
import 'package:lori_sdk/data/api/sales/sales_retailer_api.dart';
import 'package:lori_sdk/data/api/sales/sales_search_api.dart';

class SalesApi {
//  final Dio _requester;

  final SalesCatalogApi catalog;
  final SalesCommerceApi commerce;
  final SalesMarketingApi marketing;
  final SalesRetailerApi retailer;
  final SalesSearchApi search;

  SalesApi({@required Dio requester}) :
        this.catalog = SalesCatalogApi(requester: requester),
        this.commerce = SalesCommerceApi(requester: requester),
        this.marketing = SalesMarketingApi(requester: requester),
        this.retailer = SalesRetailerApi(requester: requester),
        this.search = SalesSearchApi(requester: requester);
}