import 'dart:async';

import 'package:lori_sdk/data/database/interfaces/userDao.dart';
import 'package:lori_sdk/data/models/user.dart';

class UserSingleton {
  // Singleton part
  static final UserSingleton _singleton = UserSingleton._internal();

  factory UserSingleton() {
    return _singleton;
  }

  UserSingleton._internal();

  // Class part
  // ignore: close_sinks
  var _userStream = StreamController<User>.broadcast(sync: true);

  Future<StreamSubscription<User>> registerToStream(Function callback) async {
    StreamSubscription<User> subscription = _userStream.stream.listen(callback);
    // Make sure to call cart changed this time
    var user = await UserDao().get();
    userChanged(user);
    return subscription;
  }

  void userChanged(User user) {
    _userStream.sink.add(user);
  }

  void userClose() async {
    await _userStream.sink.close();
  }
}
